
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "postfix.h"
#include "overload.h"
#include "noise.h"
#include "tuples.h"
#include "mathmap.h"

void solve_linear_equations (int dim, float *a, float *b);
void get_orig_val_pixel (mathmap_invocation_t *invocation, float x, float y, unsigned char *pixel, int drawable_index, int frame);
void get_orig_val_intersample_pixel (mathmap_invocation_t *invocation, float x, float y, unsigned char *pixel, int drawable_index, int frame);

void
get_orig_val_pixel_func (mathmap_invocation_t *invocation, float x, float y, unsigned char *pixel, int drawable_index, int frame)
{
    if (invocation->antialiasing)
        get_orig_val_intersample_pixel(invocation, x, y, pixel, drawable_index, frame);
    else
        get_orig_val_pixel(invocation, x, y, pixel, drawable_index, frame);
}



#include <gsl/gsl_complex.h>
#include <gsl/gsl_complex_math.h>
#include <gsl/gsl_sf_gamma.h>
#include "spec_func.h"


void builtin_print (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        printf("[");
    {
        int i_1;

        for (i_1 = 0; i_1 < invocation->stack[invocation->stackp - 1 + 0].length; ++i_1)
        {
            printf("%f ", invocation->stack[invocation->stackp - 1].data[i_1]);
        }
    }
    printf("]\n");
        invocation->stackp -= 0;
    }


void builtin_add_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] + invocation->stack[invocation->stackp - 1].data[0];
    invocation->stack[invocation->stackp - 2].data[1] = invocation->stack[invocation->stackp - 2].data[1] + invocation->stack[invocation->stackp - 1].data[1];
        invocation->stackp -= 1;
    }

void builtin_add_ri_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] + invocation->stack[invocation->stackp - 1].data[0];
    invocation->stack[invocation->stackp - 2].data[1] = invocation->stack[invocation->stackp - 2].data[1];
        invocation->stackp -= 1;
    }

void builtin_add_1_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] + invocation->stack[invocation->stackp - 1].data[0];
    invocation->stack[invocation->stackp - 2].data[1] =             invocation->stack[invocation->stackp - 1].data[1];
        invocation->stackp -= 1;
    }

void builtin_add_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] + invocation->stack[invocation->stackp - 1].data[0];
        invocation->stackp -= 1;
    }

void builtin_add_s (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_2;

        for (i_2 = 0; i_2 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_2)
        {
            invocation->stack[invocation->stackp - 2].data[i_2] = invocation->stack[invocation->stackp - 2].data[i_2] + invocation->stack[invocation->stackp - 1].data[0];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_add_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_3;

        for (i_3 = 0; i_3 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_3)
        {
            invocation->stack[invocation->stackp - 2].data[i_3] = invocation->stack[invocation->stackp - 2].data[i_3] + invocation->stack[invocation->stackp - 1].data[i_3];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_sub_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] - invocation->stack[invocation->stackp - 1].data[0];
    invocation->stack[invocation->stackp - 2].data[1] = invocation->stack[invocation->stackp - 2].data[1] - invocation->stack[invocation->stackp - 1].data[1];
        invocation->stackp -= 1;
    }

void builtin_sub_ri_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] - invocation->stack[invocation->stackp - 1].data[0];
    invocation->stack[invocation->stackp - 2].data[1] = invocation->stack[invocation->stackp - 2].data[1];
        invocation->stackp -= 1;
    }

void builtin_sub_1_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] - invocation->stack[invocation->stackp - 1].data[0];
    invocation->stack[invocation->stackp - 2].data[1] =           - invocation->stack[invocation->stackp - 1].data[1];
        invocation->stackp -= 1;
    }

void builtin_sub_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] - invocation->stack[invocation->stackp - 1].data[0];
        invocation->stackp -= 1;
    }

void builtin_sub_s (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_4;

        for (i_4 = 0; i_4 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_4)
        {
            invocation->stack[invocation->stackp - 2].data[i_4] = invocation->stack[invocation->stackp - 2].data[i_4] - invocation->stack[invocation->stackp - 1].data[0];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_sub_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_5;

        for (i_5 = 0; i_5 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_5)
        {
            invocation->stack[invocation->stackp - 2].data[i_5] = invocation->stack[invocation->stackp - 2].data[i_5] - invocation->stack[invocation->stackp - 1].data[i_5];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_neg (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_6;

        for (i_6 = 0; i_6 < invocation->stack[invocation->stackp - 1 + 0].length; ++i_6)
        {
            invocation->stack[invocation->stackp - 1].data[i_6] = -invocation->stack[invocation->stackp - 1].data[i_6];
        }
    }
        invocation->stackp -= 0;
    }

void builtin_mul_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float r1 = invocation->stack[invocation->stackp - 2].data[0];
    float r2 = invocation->stack[invocation->stackp - 1].data[0];
    float c1 = invocation->stack[invocation->stackp - 2].data[1];
    float c2 = invocation->stack[invocation->stackp - 1].data[1];

    invocation->stack[invocation->stackp - 2].data[0] = r1 * r2 - c1 * c2;
    invocation->stack[invocation->stackp - 2].data[1] = r1 * c2 + r2 * c1;
        invocation->stackp -= 1;
    }

void builtin_mul_1_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[0];
    invocation->stack[invocation->stackp - 2].data[1] = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[1];
        invocation->stackp -= 1;
    }


void builtin_mul_m2x2 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float a00 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[2];
float a01 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[3];
float a10 = invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[3] * invocation->stack[invocation->stackp - 1].data[2];
float a11 = invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[3] * invocation->stack[invocation->stackp - 1].data[3];

    invocation->stack[invocation->stackp - 2].data[0] = a00;
invocation->stack[invocation->stackp - 2].data[1] = a01;
invocation->stack[invocation->stackp - 2].data[2] = a10;
invocation->stack[invocation->stackp - 2].data[3] = a11;

        invocation->stackp -= 1;
    }

void builtin_mul_m3x3 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float a00 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[3]+invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[6];
float a01 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[4]+invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[7];
float a02 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[2]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[5]+invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[8];
float a10 = invocation->stack[invocation->stackp - 2].data[3] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[4] * invocation->stack[invocation->stackp - 1].data[3]+invocation->stack[invocation->stackp - 2].data[5] * invocation->stack[invocation->stackp - 1].data[6];
float a11 = invocation->stack[invocation->stackp - 2].data[3] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[4] * invocation->stack[invocation->stackp - 1].data[4]+invocation->stack[invocation->stackp - 2].data[5] * invocation->stack[invocation->stackp - 1].data[7];
float a12 = invocation->stack[invocation->stackp - 2].data[3] * invocation->stack[invocation->stackp - 1].data[2]+invocation->stack[invocation->stackp - 2].data[4] * invocation->stack[invocation->stackp - 1].data[5]+invocation->stack[invocation->stackp - 2].data[5] * invocation->stack[invocation->stackp - 1].data[8];
float a20 = invocation->stack[invocation->stackp - 2].data[6] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[7] * invocation->stack[invocation->stackp - 1].data[3]+invocation->stack[invocation->stackp - 2].data[8] * invocation->stack[invocation->stackp - 1].data[6];
float a21 = invocation->stack[invocation->stackp - 2].data[6] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[7] * invocation->stack[invocation->stackp - 1].data[4]+invocation->stack[invocation->stackp - 2].data[8] * invocation->stack[invocation->stackp - 1].data[7];
float a22 = invocation->stack[invocation->stackp - 2].data[6] * invocation->stack[invocation->stackp - 1].data[2]+invocation->stack[invocation->stackp - 2].data[7] * invocation->stack[invocation->stackp - 1].data[5]+invocation->stack[invocation->stackp - 2].data[8] * invocation->stack[invocation->stackp - 1].data[8];

    invocation->stack[invocation->stackp - 2].data[0] = a00;
invocation->stack[invocation->stackp - 2].data[1] = a01;
invocation->stack[invocation->stackp - 2].data[2] = a02;
invocation->stack[invocation->stackp - 2].data[3] = a10;
invocation->stack[invocation->stackp - 2].data[4] = a11;
invocation->stack[invocation->stackp - 2].data[5] = a12;
invocation->stack[invocation->stackp - 2].data[6] = a20;
invocation->stack[invocation->stackp - 2].data[7] = a21;
invocation->stack[invocation->stackp - 2].data[8] = a22;

        invocation->stackp -= 1;
    }


void builtin_mul_v2m2x2 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float a0 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[2];
float a1 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[3];

    invocation->stack[invocation->stackp - 2].data[0] = a0;
invocation->stack[invocation->stackp - 2].data[1] = a1;

        invocation->stackp -= 1;
    }

void builtin_mul_v3m3x3 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float a0 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[3]+invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[6];
float a1 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[4]+invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[7];
float a2 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[2]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[5]+invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[8];

    invocation->stack[invocation->stackp - 2].data[0] = a0;
invocation->stack[invocation->stackp - 2].data[1] = a1;
invocation->stack[invocation->stackp - 2].data[2] = a2;

        invocation->stackp -= 1;
    }


void builtin_mul_m2x2v2 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float a0 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[1];
float a1 = invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[3] * invocation->stack[invocation->stackp - 1].data[1];

    invocation->stack[invocation->stackp - 2].data[0] = a0;
invocation->stack[invocation->stackp - 2].data[1] = a1;

        invocation->stackp -= 1;
    }

void builtin_mul_m3x3v3 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float a0 = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[2];
float a1 = invocation->stack[invocation->stackp - 2].data[3] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[4] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[5] * invocation->stack[invocation->stackp - 1].data[2];
float a2 = invocation->stack[invocation->stackp - 2].data[6] * invocation->stack[invocation->stackp - 1].data[0]+invocation->stack[invocation->stackp - 2].data[7] * invocation->stack[invocation->stackp - 1].data[1]+invocation->stack[invocation->stackp - 2].data[8] * invocation->stack[invocation->stackp - 1].data[2];

    invocation->stack[invocation->stackp - 2].data[0] = a0;
invocation->stack[invocation->stackp - 2].data[1] = a1;
invocation->stack[invocation->stackp - 2].data[2] = a2;

        invocation->stackp -= 1;
    }

void builtin_mul_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[0];
        invocation->stackp -= 1;
    }

void builtin_mul_s (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_7;

        for (i_7 = 0; i_7 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_7)
        {
            invocation->stack[invocation->stackp - 2].data[i_7] = invocation->stack[invocation->stackp - 2].data[i_7] * invocation->stack[invocation->stackp - 1].data[0];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_mul_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_8;

        for (i_8 = 0; i_8 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_8)
        {
            invocation->stack[invocation->stackp - 2].data[i_8] = invocation->stack[invocation->stackp - 2].data[i_8] * invocation->stack[invocation->stackp - 1].data[i_8];
        }
    }
        invocation->stackp -= 1;
    }


void builtin_div_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_div(gsl_complex_rect(invocation->stack[invocation->stackp - 2].data[0],invocation->stack[invocation->stackp - 2].data[1]), gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 2].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 2].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 1;
    }

void builtin_div_1_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        double x,y,tmp;

    x = invocation->stack[invocation->stackp - 1].data[0];
    y = invocation->stack[invocation->stackp - 1].data[1];
    tmp = x * x + y * y;

    if (tmp == 0)
    {
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stack[invocation->stackp - 2].data[1] = 0.0;
    }
    else
    {
        invocation->stack[invocation->stackp - 2].data[0] =   invocation->stack[invocation->stackp - 2].data[0] * x / tmp;
        invocation->stack[invocation->stackp - 2].data[1] = - invocation->stack[invocation->stackp - 2].data[0] * y / tmp;
    }
        invocation->stackp -= 1;
    }

void builtin_div_v2m2x2 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float a[4] = { invocation->stack[invocation->stackp - 1].data[0], invocation->stack[invocation->stackp - 1].data[1], invocation->stack[invocation->stackp - 1].data[2], invocation->stack[invocation->stackp - 1].data[3] };
    float b[2] = { invocation->stack[invocation->stackp - 2].data[0], invocation->stack[invocation->stackp - 2].data[1] };

    solve_linear_equations(2, a, b);

    invocation->stack[invocation->stackp - 2].data[0] = b[0];
    invocation->stack[invocation->stackp - 2].data[1] = b[1];
        invocation->stackp -= 1;
    }

void builtin_div_v3m3x3 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float a[9] = { invocation->stack[invocation->stackp - 1].data[0], invocation->stack[invocation->stackp - 1].data[1], invocation->stack[invocation->stackp - 1].data[2], invocation->stack[invocation->stackp - 1].data[3], invocation->stack[invocation->stackp - 1].data[4], invocation->stack[invocation->stackp - 1].data[5], invocation->stack[invocation->stackp - 1].data[6], invocation->stack[invocation->stackp - 1].data[7], invocation->stack[invocation->stackp - 1].data[8] };
    float b[3] = { invocation->stack[invocation->stackp - 2].data[0], invocation->stack[invocation->stackp - 2].data[1], invocation->stack[invocation->stackp - 2].data[2] };

    solve_linear_equations(3, a, b);

    invocation->stack[invocation->stackp - 2].data[0] = b[0];
    invocation->stack[invocation->stackp - 2].data[1] = b[1];
    invocation->stack[invocation->stackp - 2].data[2] = b[2];
        invocation->stackp -= 1;
    }

void builtin_div_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] == 0)
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[0] / invocation->stack[invocation->stackp - 1].data[0];
        invocation->stackp -= 1;
    }

void builtin_div_s (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] == 0)
        {
        int i_9;

        for (i_9 = 0; i_9 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_9)
        {
            invocation->stack[invocation->stackp - 2].data[i_9] = 0.0;
        }
    }
    else
        {
        int i_10;

        for (i_10 = 0; i_10 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_10)
        {
            invocation->stack[invocation->stackp - 2].data[i_10] = invocation->stack[invocation->stackp - 2].data[i_10] / invocation->stack[invocation->stackp - 1].data[0];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_div_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_11;

        for (i_11 = 0; i_11 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_11)
        {
            if (invocation->stack[invocation->stackp - 1].data[i_11] == 0)
            invocation->stack[invocation->stackp - 2].data[i_11] = 0.0;
        else
            invocation->stack[invocation->stackp - 2].data[i_11] = invocation->stack[invocation->stackp - 2].data[i_11] / invocation->stack[invocation->stackp - 1].data[i_11];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_mod_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] == 0)
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = fmod(invocation->stack[invocation->stackp - 2].data[0], invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 1;
    }

void builtin_mod_s (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] == 0)
        {
        int i_12;

        for (i_12 = 0; i_12 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_12)
        {
            invocation->stack[invocation->stackp - 2].data[i_12] = 0.0;
        }
    }
    else
        {
        int i_13;

        for (i_13 = 0; i_13 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_13)
        {
            invocation->stack[invocation->stackp - 2].data[i_13] = fmod(invocation->stack[invocation->stackp - 2].data[i_13], invocation->stack[invocation->stackp - 1].data[0]);
        }
    }
        invocation->stackp -= 1;
    }

void builtin_mod_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_14;

        for (i_14 = 0; i_14 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_14)
        {
            if (invocation->stack[invocation->stackp - 1].data[i_14] == 0)
            invocation->stack[invocation->stackp - 2].data[i_14] = 0.0;
        else
            invocation->stack[invocation->stackp - 2].data[i_14] = fmod(invocation->stack[invocation->stackp - 2].data[i_14], invocation->stack[invocation->stackp - 1].data[i_14]);
        }
    }
        invocation->stackp -= 1;
    }

void builtin_pmod (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float mod = fmod(invocation->stack[invocation->stackp - 2].data[0], invocation->stack[invocation->stackp - 1].data[0]);

    if (invocation->stack[invocation->stackp - 2].data[0] < 0)
        mod += invocation->stack[invocation->stackp - 1].data[0];

    invocation->stack[invocation->stackp - 2].data[0] = mod;
        invocation->stackp -= 1;
    }

void builtin_sqrt_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_sqrt(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_sqrt_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = sqrt(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_sum (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float sum = 0.0;

    {
        int i_15;

        for (i_15 = 0; i_15 < invocation->stack[invocation->stackp - 1 + 0].length; ++i_15)
        {
            sum += invocation->stack[invocation->stackp - 1].data[i_15];
        }
    }
    invocation->stack[invocation->stackp - 1].data[0] = sum;
        invocation->stackp -= 0;
    }


void builtin_dotp (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float sum = 0.0;

    {
        int i_16;

        for (i_16 = 0; i_16 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_16)
        {
            sum += invocation->stack[invocation->stackp - 2].data[i_16] * invocation->stack[invocation->stackp - 1].data[i_16];
        }
    }
    invocation->stack[invocation->stackp - 2].data[0] = sum;
    invocation->stack[invocation->stackp - 2].length = 1;
        invocation->stackp -= 1;
    }

void builtin_crossp (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[2] - invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[1];
    invocation->stack[invocation->stackp - 2].data[1] = invocation->stack[invocation->stackp - 2].data[2] * invocation->stack[invocation->stackp - 1].data[0] - invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[2];
    invocation->stack[invocation->stackp - 2].data[2] = invocation->stack[invocation->stackp - 2].data[0] * invocation->stack[invocation->stackp - 1].data[1] - invocation->stack[invocation->stackp - 2].data[1] * invocation->stack[invocation->stackp - 1].data[0];
        invocation->stackp -= 1;
    }

void builtin_det_m2x2 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = invocation->stack[invocation->stackp - 1].data[0] * invocation->stack[invocation->stackp - 1].data[3] - invocation->stack[invocation->stackp - 1].data[1] * invocation->stack[invocation->stackp - 1].data[2];
        invocation->stackp -= 0;
    }

void builtin_det_m3x3 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = invocation->stack[invocation->stackp - 1].data[0] * invocation->stack[invocation->stackp - 1].data[4] * invocation->stack[invocation->stackp - 1].data[8]
                 + invocation->stack[invocation->stackp - 1].data[1] * invocation->stack[invocation->stackp - 1].data[5] * invocation->stack[invocation->stackp - 1].data[6]
                 + invocation->stack[invocation->stackp - 1].data[2] * invocation->stack[invocation->stackp - 1].data[3] * invocation->stack[invocation->stackp - 1].data[7]
                 - invocation->stack[invocation->stackp - 1].data[2] * invocation->stack[invocation->stackp - 1].data[4] * invocation->stack[invocation->stackp - 1].data[6]
                 - invocation->stack[invocation->stackp - 1].data[0] * invocation->stack[invocation->stackp - 1].data[5] * invocation->stack[invocation->stackp - 1].data[7]
                 - invocation->stack[invocation->stackp - 1].data[1] * invocation->stack[invocation->stackp - 1].data[3] * invocation->stack[invocation->stackp - 1].data[8];
        invocation->stackp -= 0;
    }

void builtin_normalize (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float l = 0.0;

    {
        int i_17;

        for (i_17 = 0; i_17 < invocation->stack[invocation->stackp - 1 + 0].length; ++i_17)
        {
            l += invocation->stack[invocation->stackp - 1].data[i_17] * invocation->stack[invocation->stackp - 1].data[i_17];
        }
    }
    l = sqrt(l);
    {
        int i_18;

        for (i_18 = 0; i_18 < invocation->stack[invocation->stackp - 1 + 0].length; ++i_18)
        {
            if (l == 0)
            invocation->stack[invocation->stackp - 1].data[i_18] = 0.0;
        else
            invocation->stack[invocation->stackp - 1].data[i_18] = invocation->stack[invocation->stackp - 1].data[i_18] / l;
        }
    }
        invocation->stackp -= 0;
    }

void builtin_abs_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = hypot( invocation->stack[invocation->stackp - 1].data[0] , invocation->stack[invocation->stackp - 1].data[1] );
    invocation->stack[invocation->stackp - 1].length = 1;
        invocation->stackp -= 0;
    }

void builtin_abs_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = fabs(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_abs_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_19;

        for (i_19 = 0; i_19 < invocation->stack[invocation->stackp - 1 + 0].length; ++i_19)
        {
            invocation->stack[invocation->stackp - 1].data[i_19] = fabs(invocation->stack[invocation->stackp - 1].data[i_19]);
        }
    }
        invocation->stackp -= 0;
    }


void builtin_deg2rad (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = invocation->stack[invocation->stackp - 1].data[0] * 0.017453292519943295722;
        invocation->stackp -= 0;
    }

void builtin_rad2deg (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = invocation->stack[invocation->stackp - 1].data[0] * 57.2957795130823208768;
        invocation->stackp -= 0;
    }

void builtin_sin_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_sin(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_sin (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = sin(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_cos_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_cos(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_cos (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = cos(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_tan_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_tan(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_tan (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = tan(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_asin_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_arcsin(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_asin (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] < -1.0 || invocation->stack[invocation->stackp - 1].data[0] > 1.0)
    {
        invocation->stack[invocation->stackp - 1].data[0] = 0.0;
    }
    else
    {
        invocation->stack[invocation->stackp - 1].data[0] = asin(invocation->stack[invocation->stackp - 1].data[0]);
    }
        invocation->stackp -= 0;
    }

void builtin_acos_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_arccos(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_acos (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] < -1.0 || invocation->stack[invocation->stackp - 1].data[0] > 1.0)
    {
        invocation->stack[invocation->stackp - 1].data[0] = 0.0;
    }
    else
    {
        invocation->stack[invocation->stackp - 1].data[0] = acos(invocation->stack[invocation->stackp - 1].data[0]);
    }
        invocation->stackp -= 0;
    }

void builtin_atan_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_arctan(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_atan (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = atan(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_atan2 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = atan2(invocation->stack[invocation->stackp - 2].data[0],invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 1;
    }


void builtin_pow_ri_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_pow(gsl_complex_rect(invocation->stack[invocation->stackp - 2].data[0],invocation->stack[invocation->stackp - 2].data[1]),gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],0));
    invocation->stack[invocation->stackp - 2].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 2].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 1;
    }

void builtin_pow_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_pow(gsl_complex_rect(invocation->stack[invocation->stackp - 2].data[0],invocation->stack[invocation->stackp - 2].data[1]),gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 2].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 2].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 1;
    }

void builtin_pow_1_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_pow(gsl_complex_rect(invocation->stack[invocation->stackp - 2].data[0],0),gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 2].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 2].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 1;
    }

void builtin_pow_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] <= 0 && invocation->stack[invocation->stackp - 2].data[0] == 0)
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = pow(invocation->stack[invocation->stackp - 2].data[0], invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 1;
    }

void builtin_pow_s (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_20;

        for (i_20 = 0; i_20 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_20)
        {
            if (invocation->stack[invocation->stackp - 1].data[0] <= 0 && invocation->stack[invocation->stackp - 2].data[i_20] == 0)
            invocation->stack[invocation->stackp - 2].data[i_20] = 0.0;
        else
            invocation->stack[invocation->stackp - 2].data[i_20] = pow(invocation->stack[invocation->stackp - 2].data[i_20], invocation->stack[invocation->stackp - 1].data[0]);
        }
    }
        invocation->stackp -= 1;
    }

void builtin_exp_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_exp(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_exp_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = exp(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_log_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_log(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_log_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] <= 0.0 )
    {
        invocation->stack[invocation->stackp - 1].data[0] = 0.0;
    }
    else
    {
        invocation->stack[invocation->stackp - 1].data[0] = log(invocation->stack[invocation->stackp - 1].data[0]);
    }
        invocation->stackp -= 0;
    }


void builtin_arg_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = gsl_complex_arg(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
        invocation->stackp -= 0;
    }

void builtin_conj_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = invocation->stack[invocation->stackp - 1].data[0];
    invocation->stack[invocation->stackp - 1].data[1] = -invocation->stack[invocation->stackp - 1].data[1];
        invocation->stackp -= 0;
    }


void builtin_sinh_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_sinh(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_sinh_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = sinh(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_cosh_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_sinh(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_cosh_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = cosh(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_tanh_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_tanh(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_tanh_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = tanh(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_asinh_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_arcsinh(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_asinh_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = asinh(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_acosh_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_arccosh(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_acosh_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = acosh(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_atanh_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = gsl_complex_arctanh(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_atanh_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = atanh(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_gamma_ri (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        gsl_complex tmp = cgamma(gsl_complex_rect(invocation->stack[invocation->stackp - 1].data[0],invocation->stack[invocation->stackp - 1].data[1]));
    invocation->stack[invocation->stackp - 1].data[0] = GSL_REAL(tmp);
    invocation->stack[invocation->stackp - 1].data[1] = GSL_IMAG(tmp);
        invocation->stackp -= 0;
    }

void builtin_gamma_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = invocation->stack[invocation->stackp - 1].data[0] > 171.0 ? 0.0 : gsl_sf_gamma(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }


void builtin_floor (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = floor(invocation->stack[invocation->stackp - 1].data[0]);
        invocation->stackp -= 0;
    }

void builtin_sign_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_21;

        for (i_21 = 0; i_21 < invocation->stack[invocation->stackp - 1 + 0].length; ++i_21)
        {
            if (invocation->stack[invocation->stackp - 1].data[i_21] < 0)
            invocation->stack[invocation->stackp - 1].data[i_21] = -1.0;
        else if (invocation->stack[invocation->stackp - 1].data[i_21] > 0)
            invocation->stack[invocation->stackp - 1].data[i_21] = 1.0;
        else
            invocation->stack[invocation->stackp - 1].data[i_21] = 0.0;
        }
    }
        invocation->stackp -= 0;
    }

void builtin_min_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_22;

        for (i_22 = 0; i_22 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_22)
        {
            if (invocation->stack[invocation->stackp - 2].data[i_22] < invocation->stack[invocation->stackp - 1].data[i_22])
            invocation->stack[invocation->stackp - 2].data[i_22] = invocation->stack[invocation->stackp - 2].data[i_22];
        else
            invocation->stack[invocation->stackp - 2].data[i_22] = invocation->stack[invocation->stackp - 1].data[i_22];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_max_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_23;

        for (i_23 = 0; i_23 < invocation->stack[invocation->stackp - 2 + 0].length; ++i_23)
        {
            if (invocation->stack[invocation->stackp - 2].data[i_23] > invocation->stack[invocation->stackp - 1].data[i_23])
            invocation->stack[invocation->stackp - 2].data[i_23] = invocation->stack[invocation->stackp - 2].data[i_23];
        else
            invocation->stack[invocation->stackp - 2].data[i_23] = invocation->stack[invocation->stackp - 1].data[i_23];
        }
    }
        invocation->stackp -= 1;
    }

void builtin_clamp (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_24;

        for (i_24 = 0; i_24 < invocation->stack[invocation->stackp - 3 + 0].length; ++i_24)
        {
            if (invocation->stack[invocation->stackp - 3].data[i_24] < invocation->stack[invocation->stackp - 2].data[i_24])
            invocation->stack[invocation->stackp - 3].data[i_24] = invocation->stack[invocation->stackp - 2].data[i_24];
        else if (invocation->stack[invocation->stackp - 3].data[i_24] > invocation->stack[invocation->stackp - 1].data[i_24])
            invocation->stack[invocation->stackp - 3].data[i_24] = invocation->stack[invocation->stackp - 1].data[i_24];
        else
            invocation->stack[invocation->stackp - 3].data[i_24] = invocation->stack[invocation->stackp - 3].data[i_24];
        }
    }
        invocation->stackp -= 2;
    }

void builtin_lerp_1 (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float l = invocation->stack[invocation->stackp - 3].data[0];
    {
        int i_25;

        for (i_25 = 0; i_25 < invocation->stack[invocation->stackp - 3 + 1].length; ++i_25)
        {
            invocation->stack[invocation->stackp - 3].data[i_25] = (1 - l) * invocation->stack[invocation->stackp - 2].data[i_25] + l * invocation->stack[invocation->stackp - 1].data[i_25];
        }
    }
        invocation->stackp -= 2;
    }

void builtin_lerp_n (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_26;

        for (i_26 = 0; i_26 < invocation->stack[invocation->stackp - 3 + 0].length; ++i_26)
        {
            invocation->stack[invocation->stackp - 3].data[i_26] = (1 - invocation->stack[invocation->stackp - 3].data[i_26]) * invocation->stack[invocation->stackp - 2].data[i_26] + invocation->stack[invocation->stackp - 3].data[i_26] * invocation->stack[invocation->stackp - 1].data[i_26];
        }
    }
        invocation->stackp -= 2;
    }

void builtin_scale (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        {
        int i_27;

        for (i_27 = 0; i_27 < invocation->stack[invocation->stackp - 5 + 0].length; ++i_27)
        {
            if (invocation->stack[invocation->stackp - 3].data[i_27] - invocation->stack[invocation->stackp - 4].data[i_27] == 0.0)
            invocation->stack[invocation->stackp - 5].data[i_27] = invocation->stack[invocation->stackp - 2].data[i_27];
        else
            invocation->stack[invocation->stackp - 5].data[i_27] = (invocation->stack[invocation->stackp - 5].data[i_27] - invocation->stack[invocation->stackp - 4].data[i_27]) / (invocation->stack[invocation->stackp - 3].data[i_27] - invocation->stack[invocation->stackp - 4].data[i_27]) * (invocation->stack[invocation->stackp - 1].data[i_27] - invocation->stack[invocation->stackp - 2].data[i_27]) + invocation->stack[invocation->stackp - 2].data[i_27];
        }
    }
        invocation->stackp -= 4;
    }


void builtin_not (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 1].data[0] != 0)
        invocation->stack[invocation->stackp - 1].data[0] = 0.0;
    else
        invocation->stack[invocation->stackp - 1].data[0] = 1.0;
        invocation->stackp -= 0;
    }

void builtin_or (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 2].data[0] || invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }

void builtin_and (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 2].data[0] && invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }

void builtin_xor (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if ((invocation->stack[invocation->stackp - 2].data[0] && !invocation->stack[invocation->stackp - 1].data[0]) || (!invocation->stack[invocation->stackp - 2].data[0] && invocation->stack[invocation->stackp - 1].data[0]))
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }


void builtin_equal (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 2].data[0] == invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }

void builtin_less (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 2].data[0] < invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }

void builtin_greater (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 2].data[0] > invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }

void builtin_lessequal (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 2].data[0] <= invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }

void builtin_greaterequal (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 2].data[0] >= invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }

void builtin_notequal (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 2].data[0] != invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 2].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 2].data[0] = 0.0;
        invocation->stackp -= 1;
    }

void builtin_inintv (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        if (invocation->stack[invocation->stackp - 3].data[0] >= invocation->stack[invocation->stackp - 2].data[0] && invocation->stack[invocation->stackp - 3].data[0] <= invocation->stack[invocation->stackp - 1].data[0])
        invocation->stack[invocation->stackp - 3].data[0] = 1.0;
    else
        invocation->stack[invocation->stackp - 3].data[0] = 0.0;
        invocation->stackp -= 2;
    }


void builtin_origval (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        unsigned char pixel[4];

    get_orig_val_pixel_func(invocation,invocation->stack[invocation->stackp - 3].data[0],invocation->stack[invocation->stackp - 3].data[1],pixel,invocation->stack[invocation->stackp - 2].data[0],invocation->stack[invocation->stackp - 1].data[0]);

    {
        int i_28;

        for (i_28 = 0; i_28 < 4; ++i_28)
        {
            invocation->stack[invocation->stackp - 3].data[i_28] = pixel[i_28] / 255.0;
        }
    }
    invocation->stack[invocation->stackp - 3].length = 4;
        invocation->stackp -= 2;
    }


void builtin_gray (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = 0.299 * invocation->stack[invocation->stackp - 1].data[0] + 0.587 * invocation->stack[invocation->stackp - 1].data[1] + 0.114 * invocation->stack[invocation->stackp - 1].data[2];
    invocation->stack[invocation->stackp - 1].length = 1;
        invocation->stackp -= 0;
    }


void builtin_tohsva (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float rgb[3] = { invocation->stack[invocation->stackp - 1].data[0], invocation->stack[invocation->stackp - 1].data[1], invocation->stack[invocation->stackp - 1].data[2] };
    float hsv[3];

    convert_rgb_to_hsv(rgb, hsv);
    invocation->stack[invocation->stackp - 1].data[0] = hsv[0];
    invocation->stack[invocation->stackp - 1].data[1] = hsv[1];
    invocation->stack[invocation->stackp - 1].data[2] = hsv[2];
    invocation->stack[invocation->stackp - 1].data[3] = invocation->stack[invocation->stackp - 1].data[3];
        invocation->stackp -= 0;
    }

void builtin_torgba (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        float hsv[3] = { invocation->stack[invocation->stackp - 1].data[0], invocation->stack[invocation->stackp - 1].data[1], invocation->stack[invocation->stackp - 1].data[2] };
    float rgb[3];

    convert_hsv_to_rgb(hsv, rgb);
    invocation->stack[invocation->stackp - 1].data[0] = rgb[0];
    invocation->stack[invocation->stackp - 1].data[1] = rgb[1];
    invocation->stack[invocation->stackp - 1].data[2] = rgb[2];
    invocation->stack[invocation->stackp - 1].data[3] = invocation->stack[invocation->stackp - 1].data[3];
        invocation->stackp -= 0;
    }


void builtin_toxy (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        double x, y;

    x = cos(invocation->stack[invocation->stackp - 1].data[1]) * invocation->stack[invocation->stackp - 1].data[0];
    y = sin(invocation->stack[invocation->stackp - 1].data[1]) * invocation->stack[invocation->stackp - 1].data[0];

    invocation->stack[invocation->stackp - 1].data[0] = x;
    invocation->stack[invocation->stackp - 1].data[1] = y;
        invocation->stackp -= 0;
    }

void builtin_tora (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        double x, y, r, a;

    x = invocation->stack[invocation->stackp - 1].data[0];
    y = invocation->stack[invocation->stackp - 1].data[1];

    r = hypot(x, y);
    if (r == 0)
        a = 0.0;
    else
        a = acos(x / r);

    if (y < 0)
        a = 2 * M_PI - a;

    invocation->stack[invocation->stackp - 1].data[0] = r;
    invocation->stack[invocation->stackp - 1].data[1] = a;
        invocation->stackp -= 0;
    }


void builtin_rand (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 2].data[0] = (rand() / (double)RAND_MAX) * (invocation->stack[invocation->stackp - 1].data[0] - invocation->stack[invocation->stackp - 2].data[0]) + invocation->stack[invocation->stackp - 2].data[0];
        invocation->stackp -= 1;
    }

void builtin_noise (mathmap_invocation_t *invocation, postfix_arg *arg)
    {
        invocation->stack[invocation->stackp - 1].data[0] = noise(invocation->stack[invocation->stackp - 1].data[0], invocation->stack[invocation->stackp - 1].data[1], invocation->stack[invocation->stackp - 1].data[2]);
        invocation->stackp -= 0;
    }
